<?php
// $Id: weblinks_link_catlink_handler.php,v 1.3 2006/10/14 13:45:12 ohwada Exp $

// 2006-10-14 K.OHWADA
// add get_lid_array_by_cid_array_orderby_where()

// 2006-09-20 K.OHWADA
// use happy_linux
// add get_lid_array_by_cid_array_orderby() : remove get_lid_array_by_cid_array_criteria()

// 2006-05-15 K.OHWADA
// this is new file
// use new handler

//=========================================================
// WebLinks Module
// 2006-05-15 K.OHWADA
//=========================================================

// === class begin ===
if( !class_exists('weblinks_link_catlink_handler') ) 
{

//=========================================================
// class weblinks_link_catlink_handler
// handling for table_link & table_catlink
//=========================================================
class weblinks_link_catlink_handler extends happy_linux_object_handler
{
	var $_table_link;
	var $_table_catlink;

// config
	var $_conf_broken;

//---------------------------------------------------------
// constructor
//---------------------------------------------------------
function weblinks_link_catlink_handler( $dirname )
{
	$this->happy_linux_object_handler($dirname, 'link_catlink', 'lid', 'weblinks' );

	$this->set_debug_db_sql(   WEBLINKS_DEBUG_LINK_CATLINK_SQL );
	$this->set_debug_db_error( WEBLINKS_DEBUG_ERROR );

	$this->_table_link     = $this->prefix( 'link',    $dirname );
	$this->_table_catlink  = $this->prefix( 'catlink', $dirname );

	$config_basic_handler =& weblinks_get_handler( 'config2_basic', $dirname );

	$conf = $config_basic_handler->get_conf();
	$this->_conf_broken  = $conf['broken_threshold'];

}

//---------------------------------------------------------
// db handling
//---------------------------------------------------------
function &get_lid_array_by_cid_orderby($cid, $orderby=null, $limit=0, $start=0)
{
	$ret =& $this->get_lid_array_by_cid_array_orderby(array($cid), $orderby, $limit, $start);
	return $ret;
}

function &get_lid_array_by_cid_array_orderby($cid_arr, $orderby=null, $limit=0, $start=0)
{
	$ret =& $this->get_lid_array_by_cid_array_orderby_where($cid_arr, $orderby, null, $limit, $start);
	return $ret;
}

function &get_lid_array_by_cid_array_orderby_where($cid_arr, $orderby=null, $where=null, $limit=0, $start=0)
{
	$ret = array();

	$count = count($cid_arr);
	if ($count == 0 )  { return $ret; }

// cid arr
	$where_cid = ' ( c.cid='.$cid_arr[0].' ';

	for ($i=1; $i<$count; $i++)
	{
		$where_cid .= ' OR c.cid='.$cid_arr[$i].' ';
	}

	$where_cid .= ' ) ';

// where
	$where_sql  = $where_cid;
	$where_sql .= ' AND l.broken < '.intval($this->_conf_broken);
	$where_sql .= ' AND l.lid=c.lid';

	if ($where)
	{
		$where_sql .= ' AND '.$where;
	}

// orderby
	if ( $orderby )
	{
		$orderby = 'l.'.$orderby;
	}
	else
	{
		$orderby = 'l.lid ASC';
	}

	$sql  = 'SELECT DISTINCT l.lid FROM ';
	$sql .= $this->_table_link.' l, ';
	$sql .= $this->_table_catlink.' c ';
	$sql .= ' WHERE ( '.$where_sql.' ) ';
	$sql .= ' ORDER BY '.$orderby;

	$ret =& $this->get_first_rows_by_sql($sql, $limit, $start);
	return $ret;
}

// --- class end ---
}

// === class end ===
}

?>